gl: Use libtool/automake.
authorMatt Birkholz <puck@birchwood-abbey.net>
Tue, 29 Mar 2016 22:10:51 +0000 (15:10 -0700)
committerMatt Birkholz <puck@birchwood-abbey.net>
Tue, 29 Mar 2016 23:50:48 +0000 (16:50 -0700)
29 files changed:
src/gl/AUTHORS [new file with mode: 0644]
src/gl/COPYING [new file with mode: 0644]
src/gl/ChangeLog [new file with mode: 0644]
src/gl/Makefile.am [new file with mode: 0644]
src/gl/Makefile.in [deleted file]
src/gl/NEWS [new file with mode: 0644]
src/gl/README [new file with mode: 0644]
src/gl/autogen.sh [new file with mode: 0755]
src/gl/check.scm
src/gl/compile.scm [deleted file]
src/gl/compile.sh [new file with mode: 0755]
src/gl/configure.ac
src/gl/gl-adapter.c
src/gl/gl-check.sh [new file with mode: 0755]
src/gl/gl-glx.scm
src/gl/gl-glxgears.scm
src/gl/gl-shim.h
src/gl/gl-tests.scm [new file with mode: 0644]
src/gl/gl.cdecl
src/gl/gl.pkg
src/gl/gl.scm
src/gl/glxgears-compile.scm
src/gl/glxgears-shim.h
src/gl/glxgears.cdecl
src/gl/glxgears.pkg
src/gl/glxgears.scm
src/gl/install-sh [new file with mode: 0755]
src/gl/mkinstalldirs [new file with mode: 0755]
src/gl/optiondb.scm [new file with mode: 0644]

diff --git a/src/gl/AUTHORS b/src/gl/AUTHORS
new file mode 100644 (file)
index 0000000..1c2a641
--- /dev/null
@@ -0,0 +1,5 @@
+To find out what should go in this file, see "Information For
+Maintainers of GNU Software" (maintain.texi), the section called
+"Recording Changes".
+
+Matthew Birkholz       Everything.
diff --git a/src/gl/COPYING b/src/gl/COPYING
new file mode 100644 (file)
index 0000000..bf50f20
--- /dev/null
@@ -0,0 +1,482 @@
+                 GNU LIBRARY GENERAL PUBLIC LICENSE
+                      Version 2, June 1991
+
+ Copyright (C) 1991 Free Software Foundation, Inc.
+                   59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+[This is the first released version of the library GPL.  It is
+ numbered 2 because it goes with version 2 of the ordinary GPL.]
+
+                           Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+Licenses are intended to guarantee your freedom to share and change
+free software--to make sure the software is free for all its users.
+
+  This license, the Library General Public License, applies to some
+specially designated Free Software Foundation software, and to any
+other libraries whose authors decide to use it.  You can use it for
+your libraries, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if
+you distribute copies of the library, or if you modify it.
+
+  For example, if you distribute copies of the library, whether gratis
+or for a fee, you must give the recipients all the rights that we gave
+you.  You must make sure that they, too, receive or can get the source
+code.  If you link a program with the library, you must provide
+complete object files to the recipients so that they can relink them
+with the library, after making changes to the library and recompiling
+it.  And you must show them these terms so they know their rights.
+
+  Our method of protecting your rights has two steps: (1) copyright
+the library, and (2) offer you this license which gives you legal
+permission to copy, distribute and/or modify the library.
+
+  Also, for each distributor's protection, we want to make certain
+that everyone understands that there is no warranty for this free
+library.  If the library is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original
+version, so that any problems introduced by others will not reflect on
+the original authors' reputations.
+\f
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that companies distributing free
+software will individually obtain patent licenses, thus in effect
+transforming the program into proprietary software.  To prevent this,
+we have made it clear that any patent must be licensed for everyone's
+free use or not licensed at all.
+
+  Most GNU software, including some libraries, is covered by the ordinary
+GNU General Public License, which was designed for utility programs.  This
+license, the GNU Library General Public License, applies to certain
+designated libraries.  This license is quite different from the ordinary
+one; be sure to read it in full, and don't assume that anything in it is
+the same as in the ordinary license.
+
+  The reason we have a separate public license for some libraries is that
+they blur the distinction we usually make between modifying or adding to a
+program and simply using it.  Linking a program with a library, without
+changing the library, is in some sense simply using the library, and is
+analogous to running a utility program or application program.  However, in
+a textual and legal sense, the linked executable is a combined work, a
+derivative of the original library, and the ordinary General Public License
+treats it as such.
+
+  Because of this blurred distinction, using the ordinary General
+Public License for libraries did not effectively promote software
+sharing, because most developers did not use the libraries.  We
+concluded that weaker conditions might promote sharing better.
+
+  However, unrestricted linking of non-free programs would deprive the
+users of those programs of all benefit from the free status of the
+libraries themselves.  This Library General Public License is intended to
+permit developers of non-free programs to use free libraries, while
+preserving your freedom as a user of such programs to change the free
+libraries that are incorporated in them.  (We have not seen how to achieve
+this as regards changes in header files, but we have achieved it as regards
+changes in the actual functions of the Library.)  The hope is that this
+will lead to faster development of free libraries.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.  Pay close attention to the difference between a
+"work based on the library" and a "work that uses the library".  The
+former contains code derived from the library, while the latter only
+works together with the library.
+
+  Note that it is possible for a library to be covered by the ordinary
+General Public License rather than by this special one.
+\f
+                 GNU LIBRARY GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License Agreement applies to any software library which
+contains a notice placed by the copyright holder or other authorized
+party saying it may be distributed under the terms of this Library
+General Public License (also called "this License").  Each licensee is
+addressed as "you".
+
+  A "library" means a collection of software functions and/or data
+prepared so as to be conveniently linked with application programs
+(which use some of those functions and data) to form executables.
+
+  The "Library", below, refers to any such software library or work
+which has been distributed under these terms.  A "work based on the
+Library" means either the Library or any derivative work under
+copyright law: that is to say, a work containing the Library or a
+portion of it, either verbatim or with modifications and/or translated
+straightforwardly into another language.  (Hereinafter, translation is
+included without limitation in the term "modification".)
+
+  "Source code" for a work means the preferred form of the work for
+making modifications to it.  For a library, complete source code means
+all the source code for all modules it contains, plus any associated
+interface definition files, plus the scripts used to control compilation
+and installation of the library.
+
+  Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running a program using the Library is not restricted, and output from
+such a program is covered only if its contents constitute a work based
+on the Library (independent of the use of the Library in a tool for
+writing it).  Whether that is true depends on what the Library does
+and what the program that uses the Library does.
+  
+  1. You may copy and distribute verbatim copies of the Library's
+complete source code as you receive it, in any medium, provided that
+you conspicuously and appropriately publish on each copy an
+appropriate copyright notice and disclaimer of warranty; keep intact
+all the notices that refer to this License and to the absence of any
+warranty; and distribute a copy of this License along with the
+Library.
+
+  You may charge a fee for the physical act of transferring a copy,
+and you may at your option offer warranty protection in exchange for a
+fee.
+\f
+  2. You may modify your copy or copies of the Library or any portion
+of it, thus forming a work based on the Library, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) The modified work must itself be a software library.
+
+    b) You must cause the files modified to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    c) You must cause the whole of the work to be licensed at no
+    charge to all third parties under the terms of this License.
+
+    d) If a facility in the modified Library refers to a function or a
+    table of data to be supplied by an application program that uses
+    the facility, other than as an argument passed when the facility
+    is invoked, then you must make a good faith effort to ensure that,
+    in the event an application does not supply such function or
+    table, the facility still operates, and performs whatever part of
+    its purpose remains meaningful.
+
+    (For example, a function in a library to compute square roots has
+    a purpose that is entirely well-defined independent of the
+    application.  Therefore, Subsection 2d requires that any
+    application-supplied function or table used by this function must
+    be optional: if the application does not supply it, the square
+    root function must still compute square roots.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Library,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Library, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote
+it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Library.
+
+In addition, mere aggregation of another work not based on the Library
+with the Library (or with a work based on the Library) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may opt to apply the terms of the ordinary GNU General Public
+License instead of this License to a given copy of the Library.  To do
+this, you must alter all the notices that refer to this License, so
+that they refer to the ordinary GNU General Public License, version 2,
+instead of to this License.  (If a newer version than version 2 of the
+ordinary GNU General Public License has appeared, then you can specify
+that version instead if you wish.)  Do not make any other change in
+these notices.
+\f
+  Once this change is made in a given copy, it is irreversible for
+that copy, so the ordinary GNU General Public License applies to all
+subsequent copies and derivative works made from that copy.
+
+  This option is useful when you wish to copy part of the code of
+the Library into a program that is not a library.
+
+  4. You may copy and distribute the Library (or a portion or
+derivative of it, under Section 2) in object code or executable form
+under the terms of Sections 1 and 2 above provided that you accompany
+it with the complete corresponding machine-readable source code, which
+must be distributed under the terms of Sections 1 and 2 above on a
+medium customarily used for software interchange.
+
+  If distribution of object code is made by offering access to copy
+from a designated place, then offering equivalent access to copy the
+source code from the same place satisfies the requirement to
+distribute the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  5. A program that contains no derivative of any portion of the
+Library, but is designed to work with the Library by being compiled or
+linked with it, is called a "work that uses the Library".  Such a
+work, in isolation, is not a derivative work of the Library, and
+therefore falls outside the scope of this License.
+
+  However, linking a "work that uses the Library" with the Library
+creates an executable that is a derivative of the Library (because it
+contains portions of the Library), rather than a "work that uses the
+library".  The executable is therefore covered by this License.
+Section 6 states terms for distribution of such executables.
+
+  When a "work that uses the Library" uses material from a header file
+that is part of the Library, the object code for the work may be a
+derivative work of the Library even though the source code is not.
+Whether this is true is especially significant if the work can be
+linked without the Library, or if the work is itself a library.  The
+threshold for this to be true is not precisely defined by law.
+
+  If such an object file uses only numerical parameters, data
+structure layouts and accessors, and small macros and small inline
+functions (ten lines or less in length), then the use of the object
+file is unrestricted, regardless of whether it is legally a derivative
+work.  (Executables containing this object code plus portions of the
+Library will still fall under Section 6.)
+
+  Otherwise, if the work is a derivative of the Library, you may
+distribute the object code for the work under the terms of Section 6.
+Any executables containing that work also fall under Section 6,
+whether or not they are linked directly with the Library itself.
+\f
+  6. As an exception to the Sections above, you may also compile or
+link a "work that uses the Library" with the Library to produce a
+work containing portions of the Library, and distribute that work
+under terms of your choice, provided that the terms permit
+modification of the work for the customer's own use and reverse
+engineering for debugging such modifications.
+
+  You must give prominent notice with each copy of the work that the
+Library is used in it and that the Library and its use are covered by
+this License.  You must supply a copy of this License.  If the work
+during execution displays copyright notices, you must include the
+copyright notice for the Library among them, as well as a reference
+directing the user to the copy of this License.  Also, you must do one
+of these things:
+
+    a) Accompany the work with the complete corresponding
+    machine-readable source code for the Library including whatever
+    changes were used in the work (which must be distributed under
+    Sections 1 and 2 above); and, if the work is an executable linked
+    with the Library, with the complete machine-readable "work that
+    uses the Library", as object code and/or source code, so that the
+    user can modify the Library and then relink to produce a modified
+    executable containing the modified Library.  (It is understood
+    that the user who changes the contents of definitions files in the
+    Library will not necessarily be able to recompile the application
+    to use the modified definitions.)
+
+    b) Accompany the work with a written offer, valid for at
+    least three years, to give the same user the materials
+    specified in Subsection 6a, above, for a charge no more
+    than the cost of performing this distribution.
+
+    c) If distribution of the work is made by offering access to copy
+    from a designated place, offer equivalent access to copy the above
+    specified materials from the same place.
+
+    d) Verify that the user has already received a copy of these
+    materials or that you have already sent this user a copy.
+
+  For an executable, the required form of the "work that uses the
+Library" must include any data and utility programs needed for
+reproducing the executable from it.  However, as a special exception,
+the source code distributed need not include anything that is normally
+distributed (in either source or binary form) with the major
+components (compiler, kernel, and so on) of the operating system on
+which the executable runs, unless that component itself accompanies
+the executable.
+
+  It may happen that this requirement contradicts the license
+restrictions of other proprietary libraries that do not normally
+accompany the operating system.  Such a contradiction means you cannot
+use both them and the Library together in an executable that you
+distribute.
+\f
+  7. You may place library facilities that are a work based on the
+Library side-by-side in a single library together with other library
+facilities not covered by this License, and distribute such a combined
+library, provided that the separate distribution of the work based on
+the Library and of the other library facilities is otherwise
+permitted, and provided that you do these two things:
+
+    a) Accompany the combined library with a copy of the same work
+    based on the Library, uncombined with any other library
+    facilities.  This must be distributed under the terms of the
+    Sections above.
+
+    b) Give prominent notice with the combined library of the fact
+    that part of it is a work based on the Library, and explaining
+    where to find the accompanying uncombined form of the same work.
+
+  8. You may not copy, modify, sublicense, link with, or distribute
+the Library except as expressly provided under this License.  Any
+attempt otherwise to copy, modify, sublicense, link with, or
+distribute the Library is void, and will automatically terminate your
+rights under this License.  However, parties who have received copies,
+or rights, from you under this License will not have their licenses
+terminated so long as such parties remain in full compliance.
+
+  9. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Library or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Library (or any work based on the
+Library), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Library or works based on it.
+
+  10. Each time you redistribute the Library (or any work based on the
+Library), the recipient automatically receives a license from the
+original licensor to copy, distribute, link with or modify the Library
+subject to these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+\f
+  11. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Library at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Library by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Library.
+
+If any portion of this section is held invalid or unenforceable under any
+particular circumstance, the balance of the section is intended to apply,
+and the section as a whole is intended to apply in other circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  12. If the distribution and/or use of the Library is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Library under this License may add
+an explicit geographical distribution limitation excluding those countries,
+so that distribution is permitted only in or among countries not thus
+excluded.  In such case, this License incorporates the limitation as if
+written in the body of this License.
+
+  13. The Free Software Foundation may publish revised and/or new
+versions of the Library General Public License from time to time.
+Such new versions will be similar in spirit to the present version,
+but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Library
+specifies a version number of this License which applies to it and
+"any later version", you have the option of following the terms and
+conditions either of that version or of any later version published by
+the Free Software Foundation.  If the Library does not specify a
+license version number, you may choose any version ever published by
+the Free Software Foundation.
+\f
+  14. If you wish to incorporate parts of the Library into other free
+programs whose distribution conditions are incompatible with these,
+write to the author to ask for permission.  For software which is
+copyrighted by the Free Software Foundation, write to the Free
+Software Foundation; we sometimes make exceptions for this.  Our
+decision will be guided by the two goals of preserving the free status
+of all derivatives of our free software and of promoting the sharing
+and reuse of software generally.
+
+                           NO WARRANTY
+
+  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
+WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
+EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
+OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
+KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
+LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
+THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
+WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
+AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
+FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
+CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
+LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
+RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
+FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
+SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+DAMAGES.
+
+                    END OF TERMS AND CONDITIONS
+\f
+           How to Apply These Terms to Your New Libraries
+
+  If you develop a new library, and you want it to be of the greatest
+possible use to the public, we recommend making it free software that
+everyone can redistribute and change.  You can do so by permitting
+redistribution under these terms (or, alternatively, under the terms of the
+ordinary General Public License).
+
+  To apply these terms, attach the following notices to the library.  It is
+safest to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least the
+"copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the library's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Library General Public
+    License as published by the Free Software Foundation; either
+    version 2 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Library General Public License for more details.
+
+    You should have received a copy of the GNU Library General Public
+    License along with this library; if not, write to the 
+    Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
+    Boston, MA  02111-1307  USA.
+
+Also add information on how to contact you by electronic and paper mail.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the library, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the
+  library `Frob' (a library for tweaking knobs) written by James Random Hacker.
+
+  <signature of Ty Coon>, 1 April 1990
+  Ty Coon, President of Vice
+
+That's all there is to it!
diff --git a/src/gl/ChangeLog b/src/gl/ChangeLog
new file mode 100644 (file)
index 0000000..25b3812
--- /dev/null
@@ -0,0 +1,8 @@
+-*-Text-*-
+
+Please see the git commit log:
+
+$ git clone git://git.savannah.gnu.org/mit-scheme.git
+$ git remote add puck git://birchwood-abbey.net/~matt/mit-scheme.git
+$ git fetch puck Gtk
+$ git log puck/Gtk -- src/gl/ | more
diff --git a/src/gl/Makefile.am b/src/gl/Makefile.am
new file mode 100644 (file)
index 0000000..f58449c
--- /dev/null
@@ -0,0 +1,107 @@
+## Process this file with automake to produce Makefile.in
+##
+## Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+##     2016 Matthew Birkholz
+##
+## This file is part of an OpenGL plugin for MIT/GNU Scheme.
+##
+## This plugin is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published
+## by the Free Software Foundation; either version 2 of the License,
+## or (at your option) any later version.
+##
+## This plugin is distributed in the hope that it will be useful, but
+## WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+## General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this plugin; if not, write to the Free Software
+## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+## 02110-1301, USA.
+
+ACLOCAL_AMFLAGS = -I m4
+EXTRA_DIST = autogen.sh
+
+MIT_SCHEME_EXE = @MIT_SCHEME_EXE@
+scmlibdir = $(libdir)/mit-scheme-@MIT_SCHEME_ARCH@
+scmlib_gldir = $(scmlibdir)/gl
+
+scmlib_LTLIBRARIES = gl-shim.la
+scmlib_DATA = gl-types.bin gl-const.bin
+
+scmlib_gl_DATA = gl.scm gl.bin gl.bci gl.com
+scmlib_gl_DATA += gl-glx.scm gl-glx.bin gl-glx.bci gl-glx.com
+scmlib_gl_DATA += gl-glxgears.scm gl-glxgears.bin
+scmlib_gl_DATA += gl-glxgears.bci gl-glxgears.com
+scmlib_gl_DATA += make.scm gl-@MIT_SCHEME_OS_SUFFIX@.pkd
+
+#info_TEXINFOS = mit-scheme-gl.texi
+AM_MAKEINFOHTMLFLAGS = --no-split
+
+# Set these to the defaults used by Scheme.
+infodir = $(datarootdir)/info
+htmldir = $(libdir)/mit-scheme/doc
+dvidir = $(libdir)/mit-scheme/doc
+pdfdir = $(libdir)/mit-scheme/doc
+
+AM_CPPFLAGS = -I$(scmlibdir)
+AM_CFLAGS = `pkg-config --cflags gl glu gtk+-3.0`
+LIBS = `pkg-config --libs gl glu gtk+-3.0`
+
+gl_shim_la_LIBADD = gl-adapter.lo
+gl_shim_la_LDFLAGS = -module -avoid-version -shared
+
+noinst_PROGRAMS = gl-const
+gl_const_SOURCES = gl-const.c gl-shim.h
+
+gl-shim.c: stamp-shim
+gl-const.c: stamp-shim
+gl-types.bin: stamp-shim
+stamp-shim: gl.cdecl gl-shim.h
+       touch stamp-shim
+       echo '(generate-shim "gl" "#include \"gl-shim.h\"")' \
+       | $(MIT_SCHEME_EXE) --batch-mode \
+       || rm stamp-shim
+
+gl-const.bin: gl-const.scm
+       echo '(sf "gl-const")' | $(MIT_SCHEME_EXE) --batch-mode
+
+gl-const.scm: gl-const
+       ./gl-const
+
+gl.bin: stamp-scheme
+gl.bci: stamp-scheme
+gl.com: stamp-scheme
+gl-@MIT_SCHEME_OS_SUFFIX@.pkd: stamp-scheme
+stamp-scheme: stamp-shim gl.scm
+       touch stamp-scheme
+       ./compile.sh || rm stamp-scheme
+
+CLEANFILES = gl-const* gl-shim.c
+CLEANFILES += *.bin *.ext *.com *.bci *.moc *.fni *.crf *.fre *.pkd
+
+TESTS = gl-check.sh
+
+ETAGS_FILES = gl-glxgears.scm
+ETAGS_FILES += gl-adapter.c gl-shim.h gl.scm gl-glx.scm
+ETAGS_CDECLS = gl.cdecl
+ETAGS_ARGS = $(ETAGS_FILES) -r '/^([^iI].*/' $(ETAGS_CDECLS)
+TAGS_DEPENDENCIES = $(ETAGS_FILES) $(ETAGS_CDECLS)
+
+install-data-hook:
+       echo '(update-optiondb "$(DESTDIR)$(scmlibdir)/")' \
+       | $(MIT_SCHEME_EXE) --batch-mode
+
+#install-html: install-html-am
+#      echo '(update-html-index "$(DESTDIR)$(htmldir)/")' \
+#      | $(MIT_SCHEME_EXE) --batch-mode
+
+uninstall-hook:
+       echo '(update-optiondb "$(DESTDIR)$(scmlibdir)/")' \
+       | $(MIT_SCHEME_EXE) --batch-mode
+       [ -d "$(DESTDIR)$(scmlib_gldir)" ] \
+       && rmdir "$(DESTDIR)$(scmlib_gldir)"
+#      [ -d "$(DESTDIR)$(htmldir)" ]                                   \
+#      && ( echo  '(update-html-index "$(DESTDIR)$(htmldir)/")'        \
+#           | $(MIT_SCHEME_EXE) --batch-mode )
diff --git a/src/gl/Makefile.in b/src/gl/Makefile.in
deleted file mode 100644 (file)
index 5a321ab..0000000
+++ /dev/null
@@ -1,124 +0,0 @@
-# Copyright (C) 2011, 2012, 2013, 2014 Matthew Birkholz
-#
-# This file is part of an extension to MIT/GNU Scheme.
-#
-# MIT/GNU Scheme is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License as
-# published by the Free Software Foundation; either version 2 of the
-# License, or (at your option) any later version.
-#
-# MIT/GNU Scheme is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-# General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with MIT/GNU Scheme; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
-# 02110-1301, USA.
-
-MIT_SCHEME_EXE = mit-scheme
-exe = '$(MIT_SCHEME_EXE)' --batch-mode
-
-CFLAGS = @CFLAGS@
-CPPFLAGS = @CPPFLAGS@
-LDFLAGS = @LDFLAGS@
-LIBS = @LIBS@
-
-all: gl-shim.so gl-types.bin gl-const.bin
-       echo '(load "compile")' | $(exe)
-       @if [ -s gl-unx.crf ]; then \
-            echo "gl-unx.crf:0: warning: non-empty"; exit 1; fi
-
-check:
-       echo '(load "check")' | $(exe)
-
-glxgears: glxgears-shim.so glxgears-types.bin glxgears-const.bin
-       echo '(load "glxgears-compile")' | $(exe)
-       @if [ -s glxgears-unx.crf ]; then \
-           echo "glxgears-unx.crf:0: warning: non-empty"; exit 1; fi
-
-.PHONY: all check glxgears
-
-install:
-       ( echo '(begin'; \
-         echo '  (install-shim "$(DESTDIR)" "gl")'; \
-         echo '  (install-load-option "$(DESTDIR)" "gl"))' ) \
-       | $(exe) -- gl gl-glx gl-glxgears *.pkd make.scm
-
-.PHONY: install
-
-clean:
-       rm -f gl-const.scm gl-const gl-const.c gl-shim.c
-       rm -f glxgears-const.scm glxgears-const glxgears-const.c glxgears-shim.c
-       rm -f *.o *.so *.bin *.ext *.com *.bci *.moc *.fni *.crf *.fre *.pkd
-       rm -f mit-scheme-gl.html mit-scheme-gl.info
-
-distclean: clean
-       rm -f Makefile config.h config.log config.status
-
-maintainer-clean: distclean
-       rm -f configure config.h.in TAGS
-       rm -rf autom4te.cache
-
-tags:
-       etags *.h \
-           `echo *.c   | sed 's/ gl-const.c//; s/ gl-shim.c//'` \
-           `echo *.scm | sed 's/ gl-const.scm//'` gl.cdecl
-
-.PHONY: clean distclean maintainer-clean tags
-
-gl-shim.so: gl-shim.o gl-adapter.o
-       echo "(link-shim)" \
-       | $(exe) -- $(LDFLAGS) -o $@ $^ $(LIBS) \
-                       `pkg-config --libs gl glu gtk+-3.0`
-
-gl-adapter.o: gl-adapter.c gl-shim.h
-       echo '(compile-shim)' \
-       | $(exe) -- $(CPPFLAGS) `pkg-config --cflags gl gtk+-3.0` \
-                       $(CFLAGS) -c $<
-
-gl-shim.o: gl-shim.c gl-shim.h
-       echo "(compile-shim)" \
-       | $(exe) -- $(CPPFLAGS) `pkg-config --cflags gl gtk+-3.0` \
-                       $(CFLAGS) -c $<
-
-gl-shim.c gl-const.c gl-types.bin: gl-shim.h gl.cdecl
-       echo '(generate-shim "gl" "#include \"gl-shim.h\"")' | $(exe)
-
-gl-const.bin: gl-const.scm
-       echo '(sf "gl-const")' | $(exe)
-
-gl-const.scm: gl-const
-       ./gl-const
-
-gl-const: gl-const.o
-       $(CC) $(LDFLAGS) -o $@ $^ $(LIBS) `pkg-config --libs gl gtk+-3.0`
-
-gl-const.o: gl-const.c gl-shim.h
-       $(CC) `pkg-config --cflags gl gtk+-3.0` $(CPPFLAGS) $(CFLAGS) -c $<
-\f
-glxgears-shim.so: glxgears-shim.o
-       echo "(link-shim)" \
-       | $(exe) -- $(LDFLAGS) -o $@ $^ $(LIBS) `pkg-config --libs gl glu x11`
-
-glxgears-shim.o: glxgears-shim.c glxgears-shim.h
-       echo "(compile-shim)" \
-       | $(exe) -- $(CPPFLAGS) `pkg-config --cflags gl glu x11` \
-                       $(CFLAGS) -c $<
-
-glxgears-shim.c glxgears-const.c glxgears-types.bin: glxgears-shim.h glxgears.cdecl
-       echo '(generate-shim "glxgears" "#include \"glxgears-shim.h\"")' \
-       | $(exe)
-
-glxgears-const.bin: glxgears-const.scm
-       echo '(sf "glxgears-const")' | $(exe)
-
-glxgears-const.scm: glxgears-const
-       ./glxgears-const
-
-glxgears-const: glxgears-const.o
-       $(CC) $(LDFLAGS) -o $@ $^ $(LIBS) `pkg-config --libs gl glu x11`
-
-glxgears-const.o: glxgears-const.c glxgears-shim.h
-       $(CC) $(CPPFLAGS) `pkg-config --cflags gl glu x11` $(CFLAGS) -c $<
diff --git a/src/gl/NEWS b/src/gl/NEWS
new file mode 100644 (file)
index 0000000..d96be61
--- /dev/null
@@ -0,0 +1,26 @@
+mit-scheme-gl NEWS -- history of user-visible changes.
+
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
+
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
+
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
+
+This plugin is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
+
+mit-scheme-gl 0.1 - Matt Birkholz, 2016-03-13
+=============================================
+
+* Use libtool and automake, rather than the microcode's disappearing
+  module support.
diff --git a/src/gl/README b/src/gl/README
new file mode 100644 (file)
index 0000000..e305fdf
--- /dev/null
@@ -0,0 +1,18 @@
+-*-Text-*-
+
+The OpenGL/GLU/GLX 3D graphics plugin.
+
+To build and install:
+
+    ./configure
+    make all check
+    make install
+
+To use:
+
+    (load-option 'GL)
+    (make-glxgears-demo)
+
+To import into a CREF package set (.pkg file):
+
+    (global-definitions gl/)
diff --git a/src/gl/autogen.sh b/src/gl/autogen.sh
new file mode 100755 (executable)
index 0000000..8af4031
--- /dev/null
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+set -e
+rm -rf m4
+mkdir m4
+autoreconf --force --install -I m4
index 3c0fdfce1a6a0877e3052da38dfd59fd85642301..85cdccfe09bb26ea10da94eba41ad7b11d4e2a9e 100644 (file)
@@ -1,4 +1,25 @@
-#| -*-Scheme-*- |#
+#| -*-Scheme-*-
+
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
+
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
+
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
+
+This plugin is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
+
+|#
 
 ;;;; Run the GLXGears demo.
 
diff --git a/src/gl/compile.scm b/src/gl/compile.scm
deleted file mode 100644 (file)
index 4179692..0000000
+++ /dev/null
@@ -1,53 +0,0 @@
-#| -*-Scheme-*-
-
-Copyright (C) 2013  Matthew Birkholz
-
-This file is part of an extension to MIT/GNU Scheme.
-
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
-
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
-WITHOUT ANY WARRANTY; without even the implied warranty of
-MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-General Public License for more details.
-
-You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
-
-|#
-
-;;;; Compile the GL wrapper.
-
-(load-option 'CREF)
-(load-option 'SOS)
-(load-option 'FFI)
-(load-option 'GTK)
-
-(with-working-directory-pathname (directory-pathname (current-load-pathname))
-  (lambda ()
-    (with-system-library-directories
-       '("./")
-      (lambda ()
-       (if (name->package '(GL))
-           (error "The GL package already exists.")
-           (let ((package-set (package-set-pathname "gl")))
-             (if (not (file-modification-time<? "gl.pkg" package-set))
-                 (cref/generate-trivial-constructor "gl"))
-             (construct-packages-from-file (fasload package-set))))
-
-       (let ((deps '("gl-const.bin"))
-             (internals (->environment '(gl internals)))
-             (glx (->environment '(gl internals glx)))
-             (glxgears (->environment '(gl glxgears))))
-         (compile-file "gl"                deps internals)
-         (load         "gl"                     internals)
-         (compile-file "gl-glx"            deps glx)
-         (load         "gl-glx"                 glx)
-         (compile-file "gl-glxgears" deps glxgears)
-         (load         "gl-glxgears"      glxgears))))
-    (cref/generate-constructors "gl" 'ALL)))
\ No newline at end of file
diff --git a/src/gl/compile.sh b/src/gl/compile.sh
new file mode 100755 (executable)
index 0000000..ce0f5e9
--- /dev/null
@@ -0,0 +1,60 @@
+#!/bin/sh
+# -*-Scheme-*-
+#
+# Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+#     2016 Matthew Birkholz
+#
+# This file is part of an OpenGL plugin for MIT/GNU Scheme.
+#
+# This plugin is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This plugin is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this plugin; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+# Compile the GL option.
+
+set -e
+: ${MIT_SCHEME_EXE=mit-scheme}
+${MIT_SCHEME_EXE} --prepend-library . --batch-mode <<\EOF
+(begin
+
+  (parameterize ((param:suppress-loading-message? #t))
+    (load-option 'CREF)
+    (load-option 'GTK)
+    (load-option 'FFI))
+
+  (if (name->package '(GL))
+      (error "The GL package already exists."))
+  (let ((package-set (package-set-pathname "gl")))
+    (if (not (file-modification-time<? "gl.pkg" package-set))
+       (cref/generate-trivial-constructor "gl" #f))
+    (construct-packages-from-file (fasload package-set)))
+
+  (let ((deps '("gl-const.bin"))
+       (internals (->environment '(gl internals)))
+       (glx (->environment '(gl internals glx)))
+       (glxgears (->environment '(gl glxgears))))
+    (compile-file "gl"             deps internals)
+    (load         "gl"                  internals)
+    (compile-file "gl-glx"         deps glx)
+    (load         "gl-glx"              glx)
+    (compile-file "gl-glxgears" deps glxgears)
+    (load         "gl-glxgears"      glxgears))
+
+  (cref/generate-constructors "gl")
+  )
+EOF
+SUFFIX=`echo "(display (microcode-id/operating-system-suffix))" \
+       | ${MIT_SCHEME_EXE} --batch-mode`
+REPORT=gl-$SUFFIX.crf
+if [ -s "$REPORT" ]; then echo "$REPORT:1: error: not empty"; exit 1; fi
index 19801f6a89a45dac3665334c306b9dc5b23eee38..ed1761141fd42792287e71158444bc419a821079 100644 (file)
@@ -1,37 +1,40 @@
 dnl Process this file with autoconf to produce a configure script.
 
-AC_INIT([MIT/GNU Scheme gl interface],
+AC_PREREQ([2.69])
+AC_INIT([MIT/GNU Scheme gl plugin],
         [0.1],
         [puck@birchwood-abbey.net],
         [mit-scheme-gl])
 AC_CONFIG_SRCDIR([gl.pkg])
+AC_CONFIG_MACRO_DIR([m4])
 
 AC_COPYRIGHT(
-[Copyright (C) 2013  Matthew Birkholz
+[Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
+
 ])
 
 AH_TOP([/*
 
-Copyright (C) 2013 Matthew Birkholz
+Copyright (C) 2013, 2014, 2015, 2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of a plugin for MIT/GNU Scheme.
 
 MIT/GNU Scheme is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -50,15 +53,31 @@ USA.
 
 */])
 
+AM_INIT_AUTOMAKE
+
+AC_PROG_LIBTOOL
+AC_PROG_CC
+AC_PROG_CPP
+AC_PROG_INSTALL
+
+dnl Initialize libtool
+LT_PREREQ([2.2.6])
+LT_INIT([dlopen win32-dll])
+
 AC_CHECK_PROG([PKG_CONFIG], [pkg-config], [yes])
 
-if ! pkg-config --exists gl 2>/dev/null; then
+if ! pkg-config --exists gl glu gtk+-3.0 2>/dev/null; then
     AC_ERROR([libGL not found.])
 fi
 
-AC_SUBST([CFLAGS])
-AC_SUBST([CPPFLAGS])
-AC_SUBST([LDFLAGS])
-AC_SUBST([LIBS])
+: ${MIT_SCHEME_EXE=mit-scheme}
+MIT_SCHEME_ARCH=`echo "(display microcode-id/compiled-code-type)" \
+                | ${MIT_SCHEME_EXE} --batch-mode`
+MIT_SCHEME_OS_SUFFIX=`echo "(display (microcode-id/operating-system-suffix))" \
+                | ${MIT_SCHEME_EXE} --batch-mode`
+
+AC_SUBST([MIT_SCHEME_EXE])
+AC_SUBST([MIT_SCHEME_ARCH])
+AC_SUBST([MIT_SCHEME_OS_SUFFIX])
 AC_CONFIG_FILES([Makefile])
 AC_OUTPUT
index 565ed85fcd6a7b933f1d35dd33d97409ebc21dad..86b986fdb0fa9e975b251ddbe75820354bc3c09f 100644 (file)
@@ -1,26 +1,23 @@
 /* -*-C-*-
 
-Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
-    1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
-    2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013 Massachusetts
-    Institute of Technology
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 */
 
diff --git a/src/gl/gl-check.sh b/src/gl/gl-check.sh
new file mode 100755 (executable)
index 0000000..ede6774
--- /dev/null
@@ -0,0 +1,41 @@
+#!/bin/sh
+# -*-Scheme-*-
+#
+# Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+#     2016 Matthew Birkholz
+#
+# This file is part of an OpenGL plugin for MIT/GNU Scheme.
+#
+# This plugin is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This plugin is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this plugin; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+# Test the GL option.
+
+set -e
+: ${MIT_SCHEME_EXE=mit-scheme}
+${MIT_SCHEME_EXE} --prepend-library . <<\EOF
+(begin
+  (load-option 'GL)
+  (let ((new (extend-top-level-environment (->environment '(GL))))
+       (ffi (->environment '(RUNTIME FFI))))
+    (load "gl-tests" new)
+    (if (gtk-initialized?)
+       (let ((await-closed-demo (access await-closed-demo new))
+             (assert-clean-ffi (access assert-clean-ffi new)))
+         (with-gc-notification! #t await-closed-demo)
+         (assert-clean-ffi "gtk"))
+       (warn "Could not test the GTK subsystem without a DISPLAY.")))
+  )
+EOF
index b5b8e380d11b00a93008c9874e29305cef0d4df9..beab389adf23544ae35e36977f645de7c099e9b6 100644 (file)
@@ -1,23 +1,23 @@
 #| -*-Scheme-*-
 
-Copyright (C) 2013, 2014  Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 |#
 
index 4915f71ad6db3ebc4da0678ff4a849938a5e25d3..dc1d1cd418d1efad1f3e2a9f6153f5b82c76dcd2 100644 (file)
@@ -1,23 +1,23 @@
 #| -*-Scheme-*-
 
-Copyright (C) 2013  Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 |#
 
index 587f38ea29f430b254a870ec410d977aed3f8f61..a69dad8edb6ac18f76fee0c1231c5660244c9f2a 100644 (file)
@@ -1,23 +1,23 @@
 /* -*-C-*-
 
-Copyright (C) 2013 Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 */
 
diff --git a/src/gl/gl-tests.scm b/src/gl/gl-tests.scm
new file mode 100644 (file)
index 0000000..943c309
--- /dev/null
@@ -0,0 +1,49 @@
+#| -*-Scheme-*-
+
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
+
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
+
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
+
+This plugin is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
+
+|#
+
+;;;; Test procedures for the GL option.
+\f
+(define (await-closed-demo)
+  (gtk-time-slice-window! #t)
+  (make-glxgears-demo)
+  (let loop ()
+    (if (not (null? (access toplevel-windows
+                           (->environment '(gtk gtk-widget)))))
+       (begin
+         (sleep-current-thread 1000)
+         (loop)))))
+
+(define (assert-clean-ffi test-name)
+  (gc-flip)
+  (sleep-current-thread 100)           ;Ensure GC deamons finish?
+  (let ((ffi (->environment '(runtime ffi))))
+    (if (not (zero? (car ((access registered-callback-count ffi)))))
+       (error (string-append test-name" did not clean up its callbacks")))
+    (if (not (null? (access malloced-aliens ffi)))
+       (error (string-append test-name" did not free allocated memory:")
+              (map (lambda (elt)
+                     (let ((alien (weak-car elt)))
+                       (if (eq? 'uchar (alien/ctype alien))
+                           (c-peek-cstring alien)
+                           alien)))
+                   (access malloced-aliens ffi))))))
\ No newline at end of file
index 42093dad07194c41dbc138f29750ec0d2c3da313..caba6ba1a87bf3a629cca5556af73c5424b9a0a1 100644 (file)
@@ -1,23 +1,23 @@
 #| -*-Scheme-*-
 
-Copyright (C) 2013  Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 |#
 
@@ -272,7 +272,7 @@ USA.
 
 (extern int gdk_window_screen_num (window (* GdkWindow)))
 
-(extern (* GtkWindow) gtk_widget_get_parent_window
+(extern (* GdkWindow) gtk_widget_get_parent_window
        (widget (* GtkWidget)))
 
 (extern void gtk_widget_set_window
index 4f09720cb4e9a9507c103ac88b74a932056ea991..c882ebceb9a2cd89bdc04a514884905d5a6bc654 100644 (file)
@@ -1,23 +1,23 @@
 #| -*-Scheme-*-
 
-Copyright (C) 2013, 2014  Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 |#
 
index c5c5f259ed08dcc47dd0e22c87a0ac6ef849e975..d30f3526965ec1df7c038dc1464bcc0f812eb72f 100644 (file)
@@ -1,23 +1,23 @@
 #| -*-Scheme-*-
 
-Copyright (C) 2013  Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 |#
 
index 9d7cc7f3e4d927fe9562da83516d771152642233..fd47b3453f6c2569c2d88fffa187af275e04ecad 100644 (file)
@@ -1,23 +1,23 @@
 #| -*-Scheme-*-
 
-Copyright (C) 2013  Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 |#
 
@@ -33,7 +33,7 @@ USA.
        (error "The GLX-GEARS package already exists.")
        (let ((package-set (package-set-pathname "glxgears")))
          (if (not (file-exists? package-set))
-             (cref/generate-trivial-constructor "glxgears"))
+             (cref/generate-trivial-constructor "glxgears" #f))
          (construct-packages-from-file (fasload package-set))))
 
     (fluid-let ((compile-file:sf-only? #t))
index 8a917dfb03c773be34973a996419f0cf3744e555..26823392a1f5d5d7a948a936320b6878b04c3e0f 100644 (file)
@@ -1,23 +1,23 @@
 /* -*-C-*-
 
-Copyright (C) 2013 Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 */
 
index 68d540e7cd40d9163e5ae8f8bc0a877ed3326753..edb0f4b39fbf586c83ee3fe95fa291c022587092 100644 (file)
@@ -1,23 +1,23 @@
 #| -*-Scheme-*-
 
-Copyright (C) 2013  Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 |#
 
index 69fb8dcbdba4a980e73678418067c2b298383974..a21fa95a9757f5dcc5114c33cddd9d45f89c3e90 100644 (file)
@@ -1,4 +1,25 @@
-#| -*-Scheme-*- |#
+#| -*-Scheme-*-
+
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
+
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
+
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
+
+This plugin is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
+
+|#
 
 (global-definitions runtime/)
 (global-definitions ffi/)
index b63344109f87ca980a5f70eb7c8b76e2696ffa4b..a659b65bd36346bf6abd661a249320129607a557 100644 (file)
@@ -1,23 +1,23 @@
 #| -*-Scheme-*-
 
-Copyright (C) 2013  Matthew Birkholz
+Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
+    2016 Matthew Birkholz
 
-This file is part of an extension to MIT/GNU Scheme.
+This file is part of an OpenGL plugin for MIT/GNU Scheme.
 
-MIT/GNU Scheme is free software; you can redistribute it and/or modify
-it under the terms of the GNU General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at
-your option) any later version.
+This plugin is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
 
-MIT/GNU Scheme is distributed in the hope that it will be useful, but
+This plugin is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with MIT/GNU Scheme; if not, write to the Free Software
-Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
-USA.
+along with this plugin; if not, write to the Free Software Foundation,
+Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 
 |#
 
diff --git a/src/gl/install-sh b/src/gl/install-sh
new file mode 100755 (executable)
index 0000000..e9de238
--- /dev/null
@@ -0,0 +1,251 @@
+#!/bin/sh
+#
+# install - install a program, script, or datafile
+# This comes from X11R5 (mit/util/scripts/install.sh).
+#
+# Copyright 1991 by the Massachusetts Institute of Technology
+#
+# Permission to use, copy, modify, distribute, and sell this software and its
+# documentation for any purpose is hereby granted without fee, provided that
+# the above copyright notice appear in all copies and that both that
+# copyright notice and this permission notice appear in supporting
+# documentation, and that the name of M.I.T. not be used in advertising or
+# publicity pertaining to distribution of the software without specific,
+# written prior permission.  M.I.T. makes no representations about the
+# suitability of this software for any purpose.  It is provided "as is"
+# without express or implied warranty.
+#
+# Calling this script install-sh is preferred over install.sh, to prevent
+# `make' implicit rules from creating a file called install from it
+# when there is no Makefile.
+#
+# This script is compatible with the BSD install script, but was written
+# from scratch.  It can only install one file at a time, a restriction
+# shared with many OS's install programs.
+
+
+# set DOITPROG to echo to test this script
+
+# Don't use :- since 4.3BSD and earlier shells don't like it.
+doit="${DOITPROG-}"
+
+
+# put in absolute paths if you don't have them in your path; or use env. vars.
+
+mvprog="${MVPROG-mv}"
+cpprog="${CPPROG-cp}"
+chmodprog="${CHMODPROG-chmod}"
+chownprog="${CHOWNPROG-chown}"
+chgrpprog="${CHGRPPROG-chgrp}"
+stripprog="${STRIPPROG-strip}"
+rmprog="${RMPROG-rm}"
+mkdirprog="${MKDIRPROG-mkdir}"
+
+transformbasename=""
+transform_arg=""
+instcmd="$mvprog"
+chmodcmd="$chmodprog 0755"
+chowncmd=""
+chgrpcmd=""
+stripcmd=""
+rmcmd="$rmprog -f"
+mvcmd="$mvprog"
+src=""
+dst=""
+dir_arg=""
+
+while [ x"$1" != x ]; do
+    case $1 in
+       -c) instcmd="$cpprog"
+           shift
+           continue;;
+
+       -d) dir_arg=true
+           shift
+           continue;;
+
+       -m) chmodcmd="$chmodprog $2"
+           shift
+           shift
+           continue;;
+
+       -o) chowncmd="$chownprog $2"
+           shift
+           shift
+           continue;;
+
+       -g) chgrpcmd="$chgrpprog $2"
+           shift
+           shift
+           continue;;
+
+       -s) stripcmd="$stripprog"
+           shift
+           continue;;
+
+       -t=*) transformarg=`echo $1 | sed 's/-t=//'`
+           shift
+           continue;;
+
+       -b=*) transformbasename=`echo $1 | sed 's/-b=//'`
+           shift
+           continue;;
+
+       *)  if [ x"$src" = x ]
+           then
+               src=$1
+           else
+               # this colon is to work around a 386BSD /bin/sh bug
+               :
+               dst=$1
+           fi
+           shift
+           continue;;
+    esac
+done
+
+if [ x"$src" = x ]
+then
+       echo "install:  no input file specified"
+       exit 1
+else
+       true
+fi
+
+if [ x"$dir_arg" != x ]; then
+       dst=$src
+       src=""
+       
+       if [ -d $dst ]; then
+               instcmd=:
+               chmodcmd=""
+       else
+               instcmd=mkdir
+       fi
+else
+
+# Waiting for this to be detected by the "$instcmd $src $dsttmp" command
+# might cause directories to be created, which would be especially bad 
+# if $src (and thus $dsttmp) contains '*'.
+
+       if [ -f $src -o -d $src ]
+       then
+               true
+       else
+               echo "install:  $src does not exist"
+               exit 1
+       fi
+       
+       if [ x"$dst" = x ]
+       then
+               echo "install:  no destination specified"
+               exit 1
+       else
+               true
+       fi
+
+# If destination is a directory, append the input filename; if your system
+# does not like double slashes in filenames, you may need to add some logic
+
+       if [ -d $dst ]
+       then
+               dst="$dst"/`basename $src`
+       else
+               true
+       fi
+fi
+
+## this sed command emulates the dirname command
+dstdir=`echo $dst | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
+
+# Make sure that the destination directory exists.
+#  this part is taken from Noah Friedman's mkinstalldirs script
+
+# Skip lots of stat calls in the usual case.
+if [ ! -d "$dstdir" ]; then
+defaultIFS='   
+'
+IFS="${IFS-${defaultIFS}}"
+
+oIFS="${IFS}"
+# Some sh's can't handle IFS=/ for some reason.
+IFS='%'
+set - `echo ${dstdir} | sed -e 's@/@%@g' -e 's@^%@/@'`
+IFS="${oIFS}"
+
+pathcomp=''
+
+while [ $# -ne 0 ] ; do
+       pathcomp="${pathcomp}${1}"
+       shift
+
+       if [ ! -d "${pathcomp}" ] ;
+        then
+               $mkdirprog "${pathcomp}"
+       else
+               true
+       fi
+
+       pathcomp="${pathcomp}/"
+done
+fi
+
+if [ x"$dir_arg" != x ]
+then
+       $doit $instcmd $dst &&
+
+       if [ x"$chowncmd" != x ]; then $doit $chowncmd $dst; else true ; fi &&
+       if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dst; else true ; fi &&
+       if [ x"$stripcmd" != x ]; then $doit $stripcmd $dst; else true ; fi &&
+       if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dst; else true ; fi
+else
+
+# If we're going to rename the final executable, determine the name now.
+
+       if [ x"$transformarg" = x ] 
+       then
+               dstfile=`basename $dst`
+       else
+               dstfile=`basename $dst $transformbasename | 
+                       sed $transformarg`$transformbasename
+       fi
+
+# don't allow the sed command to completely eliminate the filename
+
+       if [ x"$dstfile" = x ] 
+       then
+               dstfile=`basename $dst`
+       else
+               true
+       fi
+
+# Make a temp file name in the proper directory.
+
+       dsttmp=$dstdir/#inst.$$#
+
+# Move or copy the file name to the temp name
+
+       $doit $instcmd $src $dsttmp &&
+
+       trap "rm -f ${dsttmp}" 0 &&
+
+# and set any options; do chmod last to preserve setuid bits
+
+# If any of these fail, we abort the whole thing.  If we want to
+# ignore errors from any of these, just make sure not to ignore
+# errors from the above "$doit $instcmd $src $dsttmp" command.
+
+       if [ x"$chowncmd" != x ]; then $doit $chowncmd $dsttmp; else true;fi &&
+       if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dsttmp; else true;fi &&
+       if [ x"$stripcmd" != x ]; then $doit $stripcmd $dsttmp; else true;fi &&
+       if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dsttmp; else true;fi &&
+
+# Now rename the file to the real destination.
+
+       $doit $rmcmd -f $dstdir/$dstfile &&
+       $doit $mvcmd $dsttmp $dstdir/$dstfile 
+
+fi &&
+
+
+exit 0
diff --git a/src/gl/mkinstalldirs b/src/gl/mkinstalldirs
new file mode 100755 (executable)
index 0000000..18f6d17
--- /dev/null
@@ -0,0 +1,40 @@
+#! /bin/sh
+# mkinstalldirs --- make directory hierarchy
+# Author: Noah Friedman <friedman@prep.ai.mit.edu>
+# Created: 1993-05-16
+# Public domain
+
+# $$
+
+errstatus=0
+
+for file
+do
+   set fnord `echo ":$file" | sed -ne 's/^:\//#/;s/^://;s/\// /g;s/^#/\//;p'`
+   shift
+
+   pathcomp=
+   for d
+   do
+     pathcomp="$pathcomp$d"
+     case "$pathcomp" in
+       -* ) pathcomp=./$pathcomp ;;
+     esac
+
+     if test ! -d "$pathcomp"; then
+        echo "mkdir $pathcomp"
+
+        mkdir "$pathcomp" || lasterr=$?
+
+        if test ! -d "$pathcomp"; then
+         errstatus=$lasterr
+        fi
+     fi
+
+     pathcomp="$pathcomp/"
+   done
+done
+
+exit $errstatus
+
+# mkinstalldirs ends here
diff --git a/src/gl/optiondb.scm b/src/gl/optiondb.scm
new file mode 100644 (file)
index 0000000..177fdb4
--- /dev/null
@@ -0,0 +1,15 @@
+#| -*-Scheme-*- |#
+
+;;;; Test optiondb, includes the installed system's optiondb.
+
+(define-load-option 'GL
+  (let ((pathname
+        (merge-pathnames "make"
+                         (directory-pathname (current-load-pathname)))))
+    (named-lambda (gl-option-loader)
+      (load pathname))))
+
+(further-load-options
+ (merge-pathnames "optiondb"
+                 (cadr (access library-directory-path
+                               (->environment '(runtime pathname))))))
\ No newline at end of file